import UIKit
import Flutter

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    // 注册通知 demo简单起见只适配10及其以上系统
    if #available(iOS 10.0, *) {
        UNUserNotificationCenter.current().requestAuthorization(options:[.alert, .sound, .badge]) { (accepted, error) in
            accepted ?  NSLog("用户已经授权消息通知") : NSLog("用户未授权消息通知");
            if accepted {
                UNUserNotificationCenter.current().delegate = self
            }
        }
    } else {
        // Fallback on earlier versions
    }

    
    GeneratedPluginRegistrant.register(with: self)
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }

    @available(iOS 10.0, *)
    override func userNotificationCenter(_ center: UNUserNotificationCenter, didReceive response: UNNotificationResponse, withCompletionHandler completionHandler: @escaping () -> Void) {
        // 简单起见，点击任意一条通知都清空通知并将角标清零
        UIApplication.shared.applicationIconBadgeNumber = 0
        UNUserNotificationCenter.current().removeAllDeliveredNotifications()
    }
    @available(iOS 10.0, *)
    override func userNotificationCenter(_ center: UNUserNotificationCenter, willPresent notification: UNNotification, withCompletionHandler completionHandler: @escaping (UNNotificationPresentationOptions) -> Void) {
        // 应用内展示通知时，角标不增加
        completionHandler([.alert, .sound])
    }
}
