import 'package:flutter/material.dart';
import 'package:flutter_yingyan_trace_demo/general/themes.dart';

typedef BMFRaisedButtonCallback = void Function(bool selected);

class BMFRaisedButton extends StatefulWidget {
  final String? title;
  final String? selectedTitle;
  final BMFRaisedButtonCallback? onPressed;

  const BMFRaisedButton({
    Key? key,
    this.title,
    this.selectedTitle,
    this.onPressed,
  }) : super(key: key);

  @override
  _BMFRaisedButtonState createState() => _BMFRaisedButtonState();
}

class _BMFRaisedButtonState extends State<BMFRaisedButton> {
  bool _isSelected = false;

  @override
  Widget build(BuildContext context) {
    String title;
    if (widget.selectedTitle != null) {
      title = _isSelected ? widget.selectedTitle! : widget.title ?? "";
    } else {
      title = widget.title ?? "";
    }

    return ElevatedButton(
      style: ButtonStyle(
        backgroundColor: MaterialStateProperty.all(btnBgColor),
      ),
      child: Text(
        title,
        style: TextStyle(color: Colors.white, fontSize: 14),
      ),
      onPressed: () {
        if (widget.onPressed != null) {
          widget.onPressed!(_isSelected);
        }

        if (widget.selectedTitle != null) {
          setState(() {
            _isSelected = !_isSelected;
          });
        }
      },
    );
  }
}
